/*
 *   License
 *
 * The contents of this file are subject to the Jabber Open Source License
 * Version 1.0 (the "License").  You may not copy or use this file, in either
 * source code or executable form, except in compliance with the License.  You
 * may obtain a copy of the License at http://www.jabber.com/license/ or at
 * http://www.opensource.org/.  
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 *   Copyrights
 *
 * Portions created by or assigned to Jabber.com, Inc. are 
 * Copyright (c) 2000 Jabber.com, Inc.  All Rights Reserved.  Contact
 * information for Jabber.com, Inc. is available at http://www.jabber.com/.
 *
 * Portions Copyright (c) 1999-2000 David Waite 
 *
 *   Acknowledgements
 * 
 * Special thanks to the Jabber Open Source Contributors for their
 * suggestions and support of Jabber.
 * 
 *   Changes
 *
 */

import org.jabber.jabberbeans.*;
import org.jabber.jabberbeans.serverside.*;
import org.jabber.jabberbeans.Extension.Extension;
import org.jabber.jabberbeans.util.*;
import java.io.IOException;
import java.util.Enumeration;
import java.net.*;

public class HelloWorldTransport
    implements ServerModule
{
    MessageBuilder mb;
    //PacketListener
    public void sentPacket(PacketEvent pe)
    {}

    public void receivedPacket(PacketEvent pe)
    {
	if (!(pe.getPacket() instanceof Message))
	    return;
	Message msg=(Message)pe.getPacket();
	String type=msg.getType();
	if ((type!=null)&&(type.equals("error"))) return;
	mb.reset();
	mb.setToAddress(msg.getFromAddress());
	mb.setFromAddress(msg.getToAddress());
	mb.setBody("Hello, World!");
	mb.setType(msg.getType());
       
	Enumeration e=msg.Extensions();
	if (e!=null)
	    while(e.hasMoreElements())
		mb.addExtension((Extension)e.nextElement());
	try
	{
	    ((ConnectionBean)pe.getSource()).send(mb.build());
	}
	catch (InstantiationException ie)
	{}
    }

    public void instantiate(ConnectionBean cb,String hostname)
    {
	System.err.println("started HelloWorld-t");
	mb=new MessageBuilder();
    }
}
