/*
 *   License
 *
 * The contents of this file are subject to the Jabber Open Source License
 * Version 1.0 (the "License").  You may not copy or use this file, in either
 * source code or executable form, except in compliance with the License.  You
 * may obtain a copy of the License at http://www.jabber.com/license/ or at
 * http://www.opensource.org/.  
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 *   Copyrights
 *
 * Portions created by or assigned to Jabber.com, Inc. are 
 * Copyright (c) 2000 Jabber.com, Inc.  All Rights Reserved.  Contact
 * information for Jabber.com, Inc. is available at http://www.jabber.com/.
 *
 *   Acknowledgements
 * 
 * Special thanks to the Jabber Open Source Contributors for their
 * suggestions and support of Jabber.
 * 
 *   Changes
 *
 */

import org.jabber.jabberbeans.*;
import org.jabber.jabberbeans.Extension.*;

public class RosterSiphen
{
    class Listener
	extends PacketListener
    {
	public void sendPacket(Packet p)
	{
	}
	public void getPacket(Packet p)
	{
	    System.out.println("Debug: >>" +p.toString());
	}
    }

    public abstract void main(String args[])
    {
	//address of server we are connecting to.
	InetAddress addr;

	if (argv.length!=3) 
	{
	    //error - print usage and exit.
	    java.lang.System.out.println("Usage: ");
	    java.lang.System.out.println
		("\tRosterSiphen <oldJID> <newJID> <oldpword> <newpword>");
	    return ;
	}

	//first, create two connection beans
	ConnectionBean cb1=new ConnectionBean();
	ConnectionBean cb2=new ConnectionBean();

	//next, we set the backend
	try
	{
	    Listener l=new Listener();
	    cb1.setDefaultProtocolHandler();

	    cb1.addPacketListener(l);

	    //now, we connect
	    cb1.connect(addr=InetAddress.getByName(argv[0]));
	    System.out.println("connection 1 to "+ argv[0] + " successful!");

	    cb2.setDefaultProtocolHandler();
	    cb2.addPacketListener(l);

	    //now, we connect
	    cb2.connect(addr=InetAddress.getByName(argv[1]));
	    System.out.println("connection 2 to "+ argv[1] + " successful!");
	}
	catch (InstantiationException e)
	{   //from setDefaultProtocolHandler()
	    java.lang.System.out.println
		("cannot instantiate default protocol handler:");
	    java.lang.System.out.println(e.toString());
	    return ;
	}

	catch (java.net.UnknownHostException e)
	{   //from InetAddress.getByName()
	    java.lang.System.out.println
		("DNS error finding your server:");
	    java.lang.System.out.println(e.toString());
	    return ;
	}
	catch (java.io.IOException e)
	{   //from connect
	    java.lang.System.out.println
		("IO error while attempting to connect to server:");
	    java.lang.System.out.println(e.toString());
	    return ;
	}

	//now we are connected: get the roster from server1.
	
