import org.jabber.jabberbeans.*;
import org.jabber.jabberbeans.util.JID;
import org.jabber.jabberbeans.Extension.*;
import java.net.InetAddress;

public class jtest
{
    public static void main(String argv[])
    {
	if (argv.length!=3) 
	{
	    //error - print usage and exit.
	    java.lang.System.out.println("Usage: ");
	    java.lang.System.out.println
		("\tjtest <server> <username> <password>");
	    return ;
	}
	//first, create a connection bean
	ConnectionBean cb=new ConnectionBean();
	InetAddress addr;
	//next, we set the backend
	try
	{
	    //now, we connect
	    cb.connect(addr=InetAddress.getByName(argv[0]));
	}
	
	catch (java.net.UnknownHostException e)
	{   //from InetAddress.getByName()
	    java.lang.System.out.println
		("DNS error finding your server:");
	    java.lang.System.out.println(e.toString());
	    return ;
	}
	catch (java.io.IOException e)
	{   //from connect
	    java.lang.System.out.println
		("IO error while attempting to connect to server:");
	    java.lang.System.out.println(e.toString());
	    return ;
	}

	java.lang.System.out.println("Connection succeeded!");

	//now, we construct a InfoQuery packet with auth data
	InfoQueryBuilder iqb=new InfoQueryBuilder();
	InfoQuery iq;
	//and the auth data builder
	IQAuthExtensionBuilder iqAuthb=new IQAuthExtensionBuilder();

	//we are setting info
	iqb.setType("set");

	//user and password are from the commandline, resource will be jtest.
	iqAuthb.setUsername(argv[1]);
	iqAuthb.setPassword(argv[2]);
	iqAuthb.setResource("jtest");

	//build the Auth data
	try
	{
	    iqb.addExtension(iqAuthb.build());
	}
	catch (InstantiationException e)
	{
	    //building failed ?
	    java.lang.System.out.println("Fatal Error on Auth object build:");
	    java.lang.System.out.println(e.toString());
	    return;
	}

	//build the iq packet
	try
	{
	    //build the full InfoQuery packet
	    iq=(InfoQuery)iqb.build();
	}
	catch (InstantiationException e)
	{
	    //building failed ?
	    java.lang.System.out.println("Fatal Error on IQ object build:");
	    java.lang.System.out.println(e.toString());
	    return ;
	}

	//send the InfoQuery packet to the server to log in
	cb.send(iq);
	
	java.lang.System.out.println("Send requested for IQ");
	
	MessageBuilder mb=new MessageBuilder();
	Message msg;
	//set destination user. For simplicity, this is set to yourself
        mb.setToAddress(new JID("Akuma", "jabber.org", null));
	
	mb.setBody("You are receiving this message because it is thought "+
		   "that you might care... ..that this message was sent "+
		   "out successfully using the Jabberbeans Java API for "+
		   "the Jabber Instant Messaging System.");
	try
	{
	    msg=(Message)mb.build();
	}
	catch (InstantiationException e)
	{
	    //build failed ?
	    System.out.println("error creating message packet:");
	    System.out.println(e.toString());
	    return;
	}

	//send message
	cb.send(msg);

	java.lang.System.out.println("Send requested for msg");
	
	return;
    }
}
	
	
		   
