import org.jabber.jabberbeans.*;
import org.jabber.jabberbeans.util.JID;
import org.jabber.jabberbeans.Extension.*;
import java.net.InetAddress;

public class jtest2
{
    static class JTestConnectionListener
	implements ConnectionListener
    {
	public void connected(ConnectionEvent ce)
	{
	    System.out.println("CLDebug: Connected!");
	}
	public void disconnected(ConnectionEvent ce)
	{
	    System.out.println("CLDebug: Disconnected");
	}
	public void connecting(ConnectionEvent ce)
	{
	    System.out.println("CLDebug: Connecting...");
	}
	public void connectFailed(ConnectionEvent ce)
	{
	    System.out.println("CLDebug: Connect Failed");
	}
    }
    
    static class JTestPacketListener
	implements PacketListener
    {
	public void receivedPacket(PacketEvent pe)
	{
	    System.out.println("PLDebug: RECEIVED PACKET!!! : " 
			       + pe.getPacket().toString());
	}
	public void sentPacket(PacketEvent pe)
	{
	    System.out.println("PLDebug: Sent Packet : " + 
			       pe.getPacket().toString());
	}
    }
	
    public static void main(String argv[])
    {
	//address of server we are connecting to.
	InetAddress addr;

	if (argv.length!=6) 
	{
	    //error - print usage and exit.
	    java.lang.System.out.println("Usage: ");
	    java.lang.System.out.println
		("\tjtest <server> <username> <password> " +
		 "<destuser> <destserver> \"message\"");
	    return ;
	}

	//first, create a connection bean
	ConnectionBean cb=new ConnectionBean();

	//next, we set the backend
	try
	{
	    cb.addPacketListener(new JTestPacketListener());
	    cb.addConnectionListener(new JTestConnectionListener());

	    //now, we connect
	    cb.connect(addr=InetAddress.getByName(argv[0]));
	}
	catch (java.net.UnknownHostException e)
	{   //from InetAddress.getByName()
	    java.lang.System.out.println
		("DNS error finding your server:");
	    java.lang.System.out.println(e.toString());
	    return ;
	}
	catch (java.io.IOException e)
	{   //from connect
	    java.lang.System.out.println
		("IO error while attempting to connect to server:");
	    java.lang.System.out.println(e.toString());
	    return ;
	}

	java.lang.System.out.println("Connection succeeded!");

	//now, we construct a InfoQuery packet with auth data
	InfoQueryBuilder iqb=new InfoQueryBuilder();

	//and the auth data builder
	IQAuthExtensionBuilder iqAuthb=new IQAuthExtensionBuilder();

	//we are setting info
	iqb.setType("set");

	//user and password are from the commandline, resource will be jtest.
	iqAuthb.setUsername(argv[1]);
	iqAuthb.setPassword(argv[2]);
	iqAuthb.setResource("jtest");

	//build the Auth data
	try
	{
	    iqb.addExtension(iqAuthb.build());
	}
	catch (InstantiationException e)
	{
	    //building failed ?
	    java.lang.System.out.println("Fatal Error on Auth object build:");
	    java.lang.System.out.println(e.toString());
	    return;
	}

	//build the iq packet
	try
	{
	    //build the full InfoQuery packet
	    InfoQuery iq=(InfoQuery)iqb.build();

	    //send the InfoQuery packet to the server to log in
	    cb.send(iq);
	}
	catch (InstantiationException e)
	{
	    //building failed ?
	    System.out.println("Fatal Error on IQ object build:");
	    System.out.println(e.toString());
	    return ;
	}
	
	java.lang.System.out.println("Send requested for IQ");
	
	//send presence
	PresenceBuilder pb=new PresenceBuilder();
	
	//this is presence to the irc transport on jabber.org. This will log
	//you into the #jabber channel. The best way to see this working is to
	//be on the jabber channel yourself (it is on irc.openprojects.net)
	//	JID dest=new JID("#jabberbeans","irc.jabber.org",
	//		"jtest");
	//pb.setToAddress(dest);
	try
	{
	    //build and send presence
	    cb.send(pb.build());
	}
	catch (InstantiationException e)
	{
	    //building failed ?
	    System.out.println
		("Fatal Error on Presence object build:");
	    System.out.println(e.toString());
	    return ;
	}

	//System.out.println("Presence sent to irc transport!");

	// Now prepare to send a message
	MessageBuilder mb=new MessageBuilder();
	//set destination user.
	mb.setToAddress(new JID(argv[3],argv[4],null));
	
	//suitably intelligant message
	mb.setBody(argv[5]);
	try
	{
	    Message msg=(Message)mb.build();
	    //send message
	    cb.send(msg);
	}
	catch (InstantiationException e)
	{
	    //build failed ?
	    System.out.println("error creating message packet:");
	    System.out.println(e.toString());
	    return;
	}

	java.lang.System.out.println("Send requested for msg");
	
	//note: we do not exit here because the output thread is marked as a 
	//user thread. marking it as a daemon thread causes it to be killed 
	//before the last data is sent. I'm looking for a good way around this.
	return;
    }
}
	
	
		   
