import org.jabber.jabberbeans.*;
import org.jabber.jabberbeans.Extension.*;
import java.net.InetAddress;

public class jtest3
{
    static class JTestConnectionListener
	implements ConnectionListener
    {
	public void connected(ConnectionEvent ce)
	{
	    System.out.println("CLDebug: Connected!");
	}
	public void disconnected(ConnectionEvent ce)
	{
	    System.out.println("CLDebug: Disconnected");
	}
	public void connecting(ConnectionEvent ce)
	{
	    System.out.println("CLDebug: Connecting...");
	}
	public void connectFailed(ConnectionEvent ce)
	{
	    System.out.println("CLDebug: Connect Failed");
	}
    }
    
    static class JTestPacketListener
	implements PacketListener
    {
	public void receivedPacket(PacketEvent pe)
	{
	    System.out.println("PLDebug: RECEIVED PACKET!!!");
	    System.out.println(pe.getPacket().toString());
	}
	public void sentPacket(PacketEvent pe)
	{
	    System.out.println("PLDebug: Sent Packet:");
	    System.out.println(pe.getPacket().toString());
	}
    }
	
    public static void main(String argv[])
    {
	//address of server we are connecting to.
	InetAddress addr;

	if (argv.length!=3) 
	{
	    //error - print usage and exit.
	    java.lang.System.out.println("Usage: ");
	    java.lang.System.out.println
		("\tjtest <server> <username> <password>");
	    return ;
	}

	//first, create a connection bean
	ConnectionBean cb=new ConnectionBean();

	//next, we set the backend
	try
	{
	    cb.addPacketListener(new JTestPacketListener());
	    cb.addConnectionListener(new JTestConnectionListener());

	    //now, we connect
	    cb.connect(addr=InetAddress.getByName(argv[0]));
	}
	catch (java.net.UnknownHostException e)
	{   //from InetAddress.getByName()
	    java.lang.System.out.println
		("DNS error finding your server:");
	    java.lang.System.out.println(e.toString());
	    return ;
	}
	catch (java.io.IOException e)
	{   //from connect
	    java.lang.System.out.println
		("IO error while attempting to connect to server:");
	    java.lang.System.out.println(e.toString());
	    return ;
	}

	java.lang.System.out.println("Connection succeeded!");

	//now, we construct a InfoQuery packet with reg data
	InfoQueryBuilder iqb=new InfoQueryBuilder();

	//and the auth data builder
	IQRegisterExtensionBuilder iqRegb=new IQRegisterExtensionBuilder();

	//we are setting info
	iqb.setType("get");

	//build the Reg data
	try
	{
	    iqb.addExtension(iqRegb.build());
	}
	catch (InstantiationException e)
	{
	    //building failed ?
	    java.lang.System.out.println("Fatal Error on Auth object build:");
	    java.lang.System.out.println(e.toString());
	    return;
	}

	//build the iq packet
	try
	{
	    //build the full InfoQuery packet
	    InfoQuery iq=(InfoQuery)iqb.build();

	    cb.send(iq);
	}
	catch (InstantiationException e)
	{
	    //building failed ?
	    java.lang.System.out.println("Fatal Error on IQ object build:");
	    java.lang.System.out.println(e.toString());
	    return ;
	}
	
	java.lang.System.out.println("Send requested for IQ");
	return;
    }
}
	
	
		   
