import org.jabber.jabberbeans.*;
import org.jabber.jabberbeans.Extension.*;
import java.net.InetAddress;
import java.util.Enumeration;

public class jtest5
{
    static class JTestConnectionListener
	implements ConnectionListener
    {
	public void connected(ConnectionEvent ce)
	{System.out.println("CLDebug: Connected!");}
	public void disconnected(ConnectionEvent ce)
	{System.out.println("CLDebug: Disconnected");}
	public void connecting(ConnectionEvent ce)
	{System.out.println("CLDebug: Connecting...");}
	public void connectFailed(ConnectionEvent ce)
	{System.out.println("CLDebug: Connect Failed");}
    }
    
    static class JTestPacketListener
	implements PacketListener
    {
	public void receivedPacket(PacketEvent pe)
	{System.out.println("PLDebug: Received Packet");}
	public void sentPacket(PacketEvent pe)
	{System.out.println("PLDebug: Sent Packet");}
    }
    static class JTestAgentListener
	implements PacketListener
    {
	public void receivedPacket(PacketEvent pe)
	{
	    if (!(pe.getPacket() instanceof InfoQuery))
		return;
	    Enumeration e=((InfoQuery)pe.getPacket()).Extensions();
	    if ((e==null)||(!e.hasMoreElements()))
		return;
	    Extension ext=(Extension)e.nextElement();
	    if ((ext instanceof Agent)||(ext instanceof IQAgents))
		{
		    System.out.println("JTAL: received packet");
		    System.out.println(ext);
		}
	}
	public void sentPacket(PacketEvent pe)
	{}
    }

    public static void main(String argv[])
    {
	//address of server we are connecting to.
	InetAddress addr;

	if (argv.length!=3) 
	{
	    //error - print usage and exit.
	    System.out.println("jtest5 - creates agent tree");
	    java.lang.System.out.println("Usage: ");
	    java.lang.System.out.println
		("\tjtest <server> <username> <password> ");
	    return ;
	}

	//first, create a connection bean
	ConnectionBean cb=new ConnectionBean();

	//next, we set the backend
	try
	{
	    cb.addPacketListener(new JTestPacketListener());
	    cb.addConnectionListener(new JTestConnectionListener());

	    //now, we connect
	    cb.connect(addr=InetAddress.getByName(argv[0]));
	}
	catch (java.net.UnknownHostException e)
	{   //from InetAddress.getByName()
	    java.lang.System.out.println
		("DNS error finding your server:");
	    java.lang.System.out.println(e.toString());
	    return ;
	}
	catch (java.io.IOException e)
	{   //from connect
	    java.lang.System.out.println
		("IO error while attempting to connect to server:");
	    java.lang.System.out.println(e.toString());
	    return ;
	}

	java.lang.System.out.println("Connection succeeded!");

	//now, we construct a InfoQuery packet with auth data
	InfoQueryBuilder iqb=new InfoQueryBuilder();

	//and the auth data builder
	IQAuthExtensionBuilder iqAuthb=new IQAuthExtensionBuilder();

	//we are setting info
	iqb.setType("set");

	//user and password are from the commandline, resource will be jtest.
	iqAuthb.setUsername(argv[1]);
	iqAuthb.setPassword(argv[2]);
	iqAuthb.setResource("jtest4");

	//build the Auth data
	try
	{
	    iqb.addExtension(iqAuthb.build());
	}
	catch (InstantiationException e)
	{
	    //building failed ?
	    java.lang.System.out.println("Fatal Error on Auth object build:");
	    java.lang.System.out.println(e.toString());
	    return;
	}

	//build the iq packet
	try
	{
	    //build the full InfoQuery packet
	    InfoQuery iq=(InfoQuery)iqb.build();

	    //send the InfoQuery packet to the server to log in
	    cb.send(iq);
	}
	catch (InstantiationException e)
	{
	    //building failed ?
	    System.out.println("Fatal Error on IQ object build:");
	    System.out.println(e.toString());
	    return ;
	}
	
	java.lang.System.out.println("Send requested for IQ");

	IQBean iqBean=new IQBean(cb);
	iqBean.addPacketListener(new JTestAgentListener());
	try
	    {
		IQAgentsBuilder iqab=new IQAgentsBuilder();
		iqb.reset();
		iqb.setType("get");
		iqb.addExtension(iqab.build());
		Packet p = iqb.build();
		cb.send(p);
	    }
	catch (InstantiationException e)
	    {
		System.out.println
		    ("Fatal error - cannot build roster request.");
	    }
	//send presence
	//PresenceBuilder pb=new PresenceBuilder();
	
	//this is presence to the irc transport on jabber.org. This will log
	//you into the #jabber channel. The best way to see this working is to
	//be on the jabber channel yourself (it is on irc.openprojects.net)
	//	JID dest=new JID("#jabber","irc.jabber.org",
	//		"jtest");
	//pb.setToAddress(dest);
	//try
	//{
	    //build and send presence
	    //  cb.send(pb.build());
	//}
	//catch (InstantiationException e)
	//{
	    //building failed ?
	//    System.out.println
	//	("Fatal Error on Presence object build:");
	//   System.out.println(e.toString());
	//  return ;
	//}
	
	//note: we do not exit here because the output thread is marked as a 
	//user thread. marking it as a daemon thread causes it to be killed 
	//before the last data is sent. I'm looking for a good way around this.
	return;
    }
}
	
	
		   
