package org.jabber.jabbermeister;

import org.jabber.jabberbeans.*;
import org.jabber.jabberbeans.Extension.*;

import java.applet.*;
import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.event.*;

/**
 * <code>jabbermeister</code> (not spelled jbbermeister here in the interest of
 * programmer sanity) is a sample applet which permits users to log in to
 * a Jabber server, send messages, and generally cause Mayhem in the name of
 * Jabber.
 *
 * @author David Waite &lt;mass@ufl.edu&gt;
 * @version 1.0
 * @since 1.0
 * @see Applet
 */
public class jabbermeister
    extends Applet
{
    /* :listbox: (detect double click for message, right click for menu, left
     * :		for select)
     * :status button (offline, click for menu)
     * :
     */

    /**
     * popup menu for performing actions (message, etc)
     */
    private java.awt.PopupMenu actionPopupMenu;
    
    private org.jabber.jabberbeans.ConnectionBean connection;
    /**
     * "Send Message" item
     */
    private java.awt.MenuItem messageMenuItem;
    /**
     * connection status. "Online" or "Offline"
     */
    private java.awt.Button connectStatusButton;
    /**
     * list of subscribed clients.
     */
    private java.awt.List clientList;

    private boolean weAreAnApplet =true;
    /** This method is called from within the init() method to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents () 
    {
	actionPopupMenu = new java.awt.PopupMenu ();
	actionPopupMenu.setLabel ("actionPopupMenu");
	
	messageMenuItem = new java.awt.MenuItem ();
	messageMenuItem.setLabel ("Send Message");
	
	actionPopupMenu.add (messageMenuItem);
	setLayout (new java.awt.BorderLayout ());
      
	connectStatusButton = new java.awt.Button ();
	connectStatusButton.setLabel ("offline");
	
  	add (connectStatusButton, java.awt.BorderLayout.SOUTH);
	connectStatusButton.addActionListener(new connectButtonHandler());

	clientList = new java.awt.List ();
	for (int i=0;i<20;i++)
	{
	    clientList.add(String.valueOf(i));
	}
	add (clientList, java.awt.BorderLayout.CENTER);
      
	clientList.add(actionPopupMenu);
	clientList.addMouseListener(new popupListHandler());
	setVisible(true);
	System.out.println("debug statement");
    }

    protected class connectButtonHandler
	implements ActionListener
    {
	public void actionPerformed(ActionEvent e)
	{
	    //trace up the tree to find the frame
	    Object parent = jabbermeister.this.getParent(); 
	    while ((parent!=null)&&!(parent instanceof Frame)) 
		parent = ((Component)parent).getParent(); 
	    
	    LoginDialog d;
	    //now we get the hostname
	    /*if(weAreAnApplet)
	      {
	      try
	      {
	      d= new LoginDialog((java.awt.Frame) parent,
	      java.net.InetAddress.getByName
	      (getCodeBase().getHost()));
	      } 
	      catch (java.net.UnknownHostException uhe)
	      {
	      System.out.println(uhe.toString());
	      return;
	      }
	      }
	      else
	      {*/
	    d = new LoginDialog((java.awt.Frame)parent);
	    /* }*/	    
	    //now, we scan the login dialog information
	    String servername=d.getServer();
	    String URI=d.getURI();
	    String password=d.getPassword();
	    //Debug
	    System.out.println("servername:"+servername);
	    System.out.println("URI:"+URI);
	    System.out.println("pass:"+password);

	    //now, log in!
	    try
		{
		    connection.setDefaultProtocolHandler();
		    connection.addConnectionListener(new JMStatusListener());
		    connection.connect(InetAddress.getByName(servername));
	    }
	    catch(UnknownHostException uhe)
            {
		    System.out.println("Unknown Host: "+ uhe.toString());
	    }
	    catch(InstantiationException ie)
		{
		    System.out.println("problem creating default handler:"+
				       ie.toString());
		}
	    catch(IOException ioe)
		{
		    System.out.println("error with socket:"+
				       ioe.toString());
		}
	}
    }
    protected class popupListHandler
	extends MouseAdapter
    {
	public void mousePressed(MouseEvent e) 
	{
	    maybeShowPopup(e);
	}
	
	public void mouseReleased(MouseEvent e) 
	{
	    maybeShowPopup(e);
	}
	
	private void maybeShowPopup(MouseEvent e) 
	{
	    if (e.isPopupTrigger()) 
		{
		    actionPopupMenu.show(e.getComponent(),
					 e.getX(), 
					 e.getY());
		}
	}
    }
    

    /** Initializes the applet tst */
    public void init () 
    {
	weAreAnApplet=true;

	ClassLoader cl = this.getClass().getClassLoader();
	try
	{
	    connection=(org.jabber.jabberbeans.ConnectionBean)
		java.beans.Beans.instantiate
	    (cl,"org.jabber.jabberbeans.ConnectionBean");
	}
	catch (IOException e)
	{System.out.println("IOException:"+e.toString());}
	catch (ClassNotFoundException e)
	{System.out.println("ClassNotFoundException:"+e.toString());};

	initComponents ();
    }

    protected class JMStatusListener 
	extends org.jabber.jabberbeans.ConnectionAdapter
    {
	public void connecting()
	{
	    connectStatusButton.setLabel("Connecting...");
	}
	public void connected()
	{
	    connectStatusButton.setLabel("Connected");
	}
	public void disconnected()
	{
	    connectStatusButton.setLabel("Disconnected");
	}
	public void connectFailed()
	{
	    System.out.println("Failure to connect");
	}
    }    
}
