/*
 *   License
 *
 * The contents of this file are subject to the Jabber Open Source License
 * Version 1.0 (the "License").  You may not copy or use this file, in either
 * source code or executable form, except in compliance with the License.  You
 * may obtain a copy of the License at http://www.jabber.com/license/ or at
 * http://www.opensource.org/.  
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 *   Copyrights
 *
 * Portions created by or assigned to Jabber.com, Inc. are 
 * Copyright (c) 2000 Jabber.com, Inc.  All Rights Reserved.  Contact
 * information for Jabber.com, Inc. is available at http://www.jabber.com/.
 *
 * Portions Copyright (c) 1999-2000 David Waite 
 *
 *   Acknowledgements
 * 
 * Special thanks to the Jabber Open Source Contributors for their
 * suggestions and support of Jabber.
 * 
 *   Changes
 *
 */

package org.jabber.jabberbeans;

/**
 * ConnectionListener is a listener interface, which you can implement and
 * register to handle connection status change events, such as 'disconnected'.
 * <p>
 * ConnectionAdapter is a class which implements do-nothing versions of all
 * methods below - it is provided so that you may avoid having to update your
 * classes when new methods are added or old ones are changed.
 * <p>
 * These events are all generated by the ConnectionBean object, where 
 * implementiong event listeners are registered.
 * <p>
 * @see ConnectionAdapter
 * @see ConnectionBean
 *
 * @author  David Waite <a href="mailto:dwaite@jabber.com">
 *                      <i>&lt;dwaite@jabber.com&gt;</i></a>
 * @author  $Author: mass $
 * @version $Revision: 1.9 $
 */
public interface ConnectionListener
{
    /**
     * <code>connectionChanged</code> signifies that we have had an alteration
     * in our connection status, such as a forced disconnection from the
     * server.
     */
    void connectionChanged(ConnectionEvent ce);
}
