/*
 *   License
 *
 * The contents of this file are subject to the Jabber Open Source License
 * Version 1.0 (the "License").  You may not copy or use this file, in either
 * source code or executable form, except in compliance with the License.  You
 * may obtain a copy of the License at http://www.jabber.com/license/ or at
 * http://www.opensource.org/.  
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 *   Copyrights
 *
 * Portions created by or assigned to Jabber.com, Inc. are 
 * Copyright (c) 2000 Jabber.com, Inc.  All Rights Reserved.  Contact
 * information for Jabber.com, Inc. is available at http://www.jabber.com/.
 *
 * Portions Copyright (c) 1999-2000 David Waite 
 *
 *   Acknowledgements
 * 
 * Special thanks to the Jabber Open Source Contributors for their
 * suggestions and support of Jabber.
 * 
 *   Changes
 *
 */

package org.jabber.jabberbeans.Extension;

import java.util.Hashtable;
import java.util.Enumeration;

/**
 * An <code>IQRegisterExtension</code> holds the values that would be stored in
 * a jabber:iq:register namespace. This namespace is used to register and
 * deregister accounts with the jabber server and with various transports.
 *
 * NOTE: it is my personal hope that this extension dies a horrible death at
 * a later date, probably at the hand of XML forms.
 *
 * all parameters are subject to interpretation - the names are meant to be 
 * labels to editable text boxes, with instructions being broadcast on how to
 * use the interface.
 *
 * also note that the values do not have default states - <name/> is 
 * represented by name.equals(""), whereas name=null indicates the element 
 * is not present
 *
 * @deprecated use IQRegister instead
 *
 * @author  David Waite <a href="mailto:dwaite@jabber.com">
 *                      <i>&lt;dwaite@jabber.com&gt;</i></a>
 * @author  $Author: dwaite $
 * @version $Revision: 1.12 $
 */
public class IQRegisterExtension
    extends IQRegister
{
    /** Creates a new <code>IQRegisterExtension</code> instance. */
    public IQRegisterExtension(IQRegisterBuilder builder)
        throws InstantiationException
    {
	super(builder);
    }
    
    /**
     * Used to fetch the internal XMLNS, which is used by AppendItem and
     * toString to return the proper XML representation.
     *
     * @return <code>String</code> holding the XML namespace
     */
    protected String getXMLNS()
    {
	return "jabber:iq:register";
    }
}
