/*
 *   License
 *
 * The contents of this file are subject to the Jabber Open Source License
 * Version 1.0 (the "License").  You may not copy or use this file, in either
 * source code or executable form, except in compliance with the License.  You
 * may obtain a copy of the License at http://www.jabber.com/license/ or at
 * http://www.opensource.org/.  
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 *   Copyrights
 *
 * Portions created by or assigned to Jabber.com, Inc. are 
 * Copyright (c) 2000 Jabber.com, Inc.  All Rights Reserved.  Contact
 * information for Jabber.com, Inc. is available at http://www.jabber.com/.
 *
 *   Acknowledgements
 * 
 * Special thanks to the Jabber Open Source Contributors for their
 * suggestions and support of Jabber.
 * 
 *   Changes
 *
 */

package org.jabber.jabberbeans.Extension;

import java.util.Hashtable;

/**
 * An <code>IQSearchRequestBuilder</code> is used to generate an 
 * IQSearchRequest, which is used in finding out the searchable parameters on
 * a searchable resource, or performing a search on the said resource.
 *
 * NOTE: it is my personal hope that this extension dies a horrible death at
 * a later date, probably at the hand of XML forms.
 *
 * all parameters are subject to interpretation - the names are meant to be 
 * labels to editable text boxes, with instructions being broadcast on how to
 * use the interface.
 *
 * also note that the values do not have default states - <name/> is 
 * represented by name.equals(""), whereas name=null indicates the element
 * is not present
 *
 * @see QueryExtension
 *
 * @author  David Waite <a href="mailto:dwaite@jabber.com">
 *                      <i>&lt;dwaite@jabber.com&gt;</i></a>
 * @author  $Author: mass $
 * @version $Revision: 1.5 $
 */
public class IQSearchRequestBuilder
    extends HashExtensionBuilder
{
    /**
     * Construct a new <code>IQSearchRequestBuilder</code>
     */
    public IQSearchRequestBuilder()
    {
	super();
    }

    /**
     * Create an <code>IQSearchRequest Extension</code> from the current
     * state of this builder.
     *
     * @return <code>IQSearchRequest Extension</code>
     */
    public Extension build()
	throws InstantiationException
    {
	return new IQSearchRequest(this);
    }
}
