/*
 *   License
 *
 * The contents of this file are subject to the Jabber Open Source License
 * Version 1.0 (the "License").  You may not copy or use this file, in either
 * source code or executable form, except in compliance with the License.  You
 * may obtain a copy of the License at http://www.jabber.com/license/ or at
 * http://www.opensource.org/.  
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 *   Copyrights
 *
 * Portions created by or assigned to Jabber.com, Inc. are 
 * Copyright (c) 2000 Jabber.com, Inc.  All Rights Reserved.  Contact
 * information for Jabber.com, Inc. is available at http://www.jabber.com/.
 *
 *   Acknowledgements
 * 
 * Special thanks to the Jabber Open Source Contributors for their
 * suggestions and support of Jabber.
 * 
 *   Changes
 *
 */

package org.jabber.jabberbeans.Extension;

import java.util.Hashtable;
import java.util.Enumeration;
import org.jabber.jabberbeans.*;

/**
 * A <code>SearchResult</code> represents one item in a search result.
 *
 * @author  David Waite <a href="mailto:dwaite@jabber.com">
 *                      <i>&lt;dwaite@jabber.com&gt;</i></a>
 * @author  $Author: mass $
 * @version $Revision: 1.9 $
 */
public class SearchResult
    extends HashExtension
{
    /** Creates a new <code>SearchResult</code> instance. */
    public SearchResult(SearchResultBuilder builder)
        throws InstantiationException
    {
	super(builder);
    }

    /** 
     * get the XML namespace for parent toString to work - we don't
     * use the parent toString, so we just return null.
     */
    protected String getXMLNS()
    {
	return null;
    }

    /**
     * <code>appendItem</code> appends the XML representation of the
     * current packet data to the specified <code>StringBuffer</code>.
     *
     * @param retval The <code>StringBuffer</code> to append to
     */
    public void appendItem(StringBuffer retval)
    {
	retval.append("<item>");
        Enumeration names=getNames();
        if (names!=null)
        {
            while (names.hasMoreElements())
            {
                String name=(String)names.nextElement();
                appendChild(retval,
                              name,
                              (String)getValue(name));
            }
        }
	retval.append("</item>");
    }	
}
