/*
 *   License
 *
 * The contents of this file are subject to the Jabber Open Source License
 * Version 1.0 (the "License").  You may not copy or use this file, in either
 * source code or executable form, except in compliance with the License.  You
 * may obtain a copy of the License at http://www.jabber.com/license/ or at
 * http://www.opensource.org/.  
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 *   Copyrights
 *
 * Portions created by or assigned to Jabber.com, Inc. are 
 * Copyright (c) 2000 Jabber.com, Inc.  All Rights Reserved.  Contact
 * information for Jabber.com, Inc. is available at http://www.jabber.com/.
 *
 * Portions Copyright (c) 1999-2000 David Waite 
 *
 *   Acknowledgements
 * 
 * Special thanks to the Jabber Open Source Contributors for their
 * suggestions and support of Jabber.
 * 
 *   Changes
 *
 */

package org.jabber.jabberbeans;

/**
 * <code>PacketListenerRegistrar</code> is an interface that marks the
 * existance of a subscribable packet event on an object.
 *
 * @author  David Waite <a href="mailto:dwaite@jabber.com">
 *                      <i>&lt;dwaite@jabber.com&gt;</i></a>
 * @author  $Author: mass $
 * @version $Revision: 1.7 $
 */
public interface PacketListenerRegistrar
{
    /**
     * <code>addPacketListener</code> lets you register a <code>
     * PacketListener</code> to receive connection state changes.
     *
     * @param l <code>PacketListener</code> to register
     */
    void addPacketListener(PacketListener l);

    /**
     * <code>delPacketListener</code> lets you unregister a <code>
     * PacketListener</code> that receives connection state changes.
     *
     * @param l <code>PacketListener</code> to unregister
     */    
    void delPacketListener(PacketListener l);
}
