package org.jabber.jabberbeans;

import java.util.*;
import org.jabber.jabberbeans.util.*;

/**
 *
 * @author  Shawn
 * @version 
 */

public class PresenceUserNode 
{
	//user's resources
	Hashtable resources = new Hashtable();
	
	//plain user@server name
	String name = new String();

	//Constructor
	public PresenceUserNode(JID jid, String state, String status)
	{
		String username = jid.getUsername();
		String server = jid.getServer();
		
		if(username != null)
			this.name = username + "@";
		if(server != null)
			this.name += server;
		
		ResourceNode user = new ResourceNode(jid, state, status);
		resources.put(jid, user);
	}
	
	//add a user resource to the list
	public void addResource(JID jid, String state, String status)
	{
		ResourceNode user = new ResourceNode(jid, state, status);
		resources.put(jid, user);
	}
	
	//remove a user resource from the list
	public ResourceNode removeResource(JID jid)
	{return (ResourceNode)this.resources.remove(jid);}
	
	//returns the user@server name of this node
	public String getName()
	{return name;}
	
	//return all the resources for this user
	public Hashtable getResources()
	{return this.resources;}
	
	public int getNumResources()
	{return this.resources.size();}
	
	//clear all the resources for this user
	public void clearResources()
	{this.resources = new Hashtable();}
	
	//does the list contain a certain resource?
	public boolean containsResource(JID jid)
	{
		if(jid == null)
			return false;
		return this.resources.containsKey(jid);
	}
	
	//Return the user's state
	public String getState(JID jid)
	{		
		if((ResourceNode)this.resources.get(jid) == null)
			return null;
		return ((ResourceNode)this.resources.get(jid)).getState();
	}
	
	public void setState(JID jid, String str)
	{((ResourceNode)this.resources.get(jid)).setState(str);}

	//Return the user's status
	public String getStatus(JID jid)
	{
		if((ResourceNode)this.resources.get(jid) == null)
			return null;
		return ((ResourceNode)this.resources.get(jid)).getStatus();
	}

	//Set the status on the particular resource
	public void setStatus(JID jid, String str)
	{((ResourceNode)this.resources.get(jid)).setStatus(str);}
	
	//default toString method
	public String toString()
	{return this.name;}
	
	public int hashCode()
	{return toString().toLowerCase().hashCode();}
}