package org.jabber.jabberbeans;

import java.util.*;
import org.jabber.jabberbeans.util.*;


/**
 *
 * @author  Shawn
 * @version 
 */


public class ResourceNode
{
	//create a full length jid
	JID jid = null;

	//Create a user@server string
	String name = new String();

	//the users resource
	String resource = new String();

	//user's state
	String state = new String();

	//user's status
	String status = new String();

	//plain constructor
	public ResourceNode(){}

	//full constructor
	public ResourceNode(JID jid, String state, String status)
	{
		this.jid = jid;
		
		String username = jid.getUsername();
		String server = jid.getServer();
		String resource = jid.getResource();
		
		if(username != null)
			this.name = username + "@";
		if(server != null)
			this.name += server;
		if(resource != null)
			this.resource = resource;
		
		this.state = state;
		this.status = status;
	}

	//set the full jid
	public void setJID(JID j)
	{this.jid = j;}

	//get the full jid
	public JID getJID()
	{return jid;}

	//set the short name
	public void setName(String str)
	{this.name = str;}


	//get the short name
	public String getName()
	{return name;}

	//set the resource
	public void setResource(String str)
	{this.resource = str;}

	//get the resource
	public String getResource()
	{return resource;}

	//set the user's state
	public void setState(String str)
	{this.state = str;}

	//get the state of the user (available, away, etc)
	public String getState()
	{return state;}

	//set the user status message
	public void setStatus(String str)
	{this.status = str;}

	//get the user's status message
	public String getStatus()
	{return status;}

	//toString method.  When this object must be 'printed'
	public String toString()
	{return jid.toString();}
	
	public int hashCode()
	{return toString().toLowerCase().hashCode();}
}