/*
 *   License
 *
 * The contents of this file are subject to the Jabber Open Source License
 * Version 1.0 (the "License").  You may not copy or use this file, in either
 * source code or executable form, except in compliance with the License.  You
 * may obtain a copy of the License at http://www.jabber.com/license/ or at
 * http://www.opensource.org/.  
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 *   Copyrights
 *
 * Portions created by or assigned to Jabber.com, Inc. are 
 * Copyright (c) 2000 Jabber.com, Inc.  All Rights Reserved.  Contact
 * information for Jabber.com, Inc. is available at http://www.jabber.com/.
 *
 *   Acknowledgements
 * 
 * Special thanks to the Jabber Open Source Contributors for their
 * suggestions and support of Jabber.
 * 
 *   Changes
 *
 */

package org.jabber.jabberbeans;

import org.jabber.jabberbeans.util.JID;

/**
 * Class which builds an XMLStream header - this names the overall
 * namespace (format) of the XML data being transmitted and received.
 *
 * @author  David Waite <a href="mailto:dwaite@jabber.com">
 *                      <i>&lt;dwaite@jabber.com&gt;</i></a>
 * @author  $Author: mass $
 * @version $Revision: 1.2 $
 */
public class XMLStreamHeaderBuilder
    extends PacketBuilder
{
    /** <code>XMLNS</code> holds the namespace of the protocol being spoken. */
    private String XMLNS;

    public XMLStreamHeaderBuilder()
    {
	reset();
    }

    public void reset()
    {
        XMLNS = null;
        resetBase();
    }

    public String getXMLNS()
    {
	return XMLNS;
    }
    public void setXMLNS(String xmlns)
    {
	XMLNS=xmlns;
    }

    public Packet build()
    {
	return new XMLStreamHeader(this);
    }
}
